Index: locale/en/mlx.po
===================================================================
--- locale/en/mlx.po	(revision 707)
+++ locale/en/mlx.po	(revision 708)
@@ -747,4 +747,20 @@
 msgstr "Enter the amount of extra fuel in kilograms."
 
+msgid "simbrief_takeoff_runway"
+msgstr "_Takeoff runway:"
+
+msgid "simbrief_takeoff_runway_tooltip"
+msgstr ""
+"Enter the number of the planned takeoff runway.\n"
+"If you don't want to specify it, leave it empty"
+
+msgid "simbrief_landing_runway"
+msgstr "_Landing runway:"
+
+msgid "simbrief_landing_runway_tooltip"
+msgstr ""
+"Enter the number of the planned landing runway.\n"
+"If you don't want to specify it, leave it empty"
+
 msgid "simbrief_progress_searching_browser"
 msgstr "Searching browser..."
Index: locale/hu/mlx.po
===================================================================
--- locale/hu/mlx.po	(revision 707)
+++ locale/hu/mlx.po	(revision 708)
@@ -745,4 +745,20 @@
 msgstr "Írd be az extra üzemanyag mennyiségéet kilogrammban."
 
+msgid "simbrief_takeoff_runway"
+msgstr "_Felszálló futópálya:"
+
+msgid "simbrief_takeoff_runway_tooltip"
+msgstr
+"Írd be a tervezett felszálló futópálya számát.\n"
+"Ha nem akarod megadni, hagyd üresen a mezőt."
+
+msgid "simbrief_landing_runway"
+msgstr "_Leszálló futópálya:"
+
+msgid "simbrief_landing_runway_tooltip"
+msgstr
+"Írd be a tervezett leszálló futópálya számát.\n"
+"Ha nem akarod megadni, hagyd üresen a mezőt."
+
 msgid "simbrief_progress_searching_browser"
 msgstr "Böngésző keresése..."
Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 707)
+++ src/mlx/gui/flight.py	(revision 708)
@@ -1823,4 +1823,28 @@
         table.attach(gtk.Label("kg"), 2, 3, 3, 4)
 
+        label = gtk.Label(xstr("simbrief_takeoff_runway"))
+        label.set_use_underline(True)
+        label.set_alignment(0.0, 0.5)
+        table.attach(label, 0, 1, 4, 5)
+
+        self._takeoffRunway = gtk.Entry()
+        self._takeoffRunway.set_width_chars(10)
+        self._takeoffRunway.set_tooltip_text(xstr("simbrief_takeoff_runway_tooltip"))
+        self._takeoffRunway.connect("changed", self._upperChanged)
+        table.attach(self._takeoffRunway, 1, 2, 4, 5)
+        label.set_mnemonic_widget(self._takeoffRunway)
+
+        label = gtk.Label(xstr("simbrief_landing_runway"))
+        label.set_use_underline(True)
+        label.set_alignment(0.0, 0.5)
+        table.attach(label, 0, 1, 5, 6)
+
+        self._landingRunway = gtk.Entry()
+        self._landingRunway.set_width_chars(10)
+        self._landingRunway.set_tooltip_text(xstr("simbrief_takeoff_runway_tooltip"))
+        self._landingRunway.connect("changed", self._upperChanged)
+        table.attach(self._landingRunway, 1, 2, 5, 6)
+        label.set_mnemonic_widget(self._landingRunway)
+
         self.addCancelFlightButton()
 
@@ -1843,4 +1867,10 @@
         self._extraFuel.set_int(0)
         self._extraFuel.set_sensitive(True)
+
+        self._takeoffRunway.set_text("")
+        self._takeoffRunway.set_sensitive(True)
+
+        self._landingRunway.set_text("")
+        self._landingRunway.set_sensitive(True)
 
         self._updateForwardButton()
@@ -1877,4 +1907,6 @@
             self._rememberButton.set_sensitive(False)
             self._extraFuel.set_sensitive(False)
+            self._takeoffRunway.set_sensitive(False)
+            self._landingRunway.set_sensitive(False)
 
             self._wizard.gui.beginBusy("Calling SimBrief...")
@@ -2023,6 +2055,6 @@
 
         plan["addedfuel"] = str(self._extraFuel.get_int() / 1000.0)
-        plan["origrwy"] = "" # FIXME: query
-        plan["destrwy"] = "" # FIXME: query
+        plan["origrwy"] = self._takeoffRunway.get_text()
+        plan["destrwy"] = self._landingRunway.get_text()
         plan["climb"] = "250/300/78" # FIXME: query
         plan["cruise"] = "LRC" # FIXME: query
@@ -2030,4 +2062,9 @@
 
         return plan
+
+    def _upperChanged(self, entry, arg = None):
+        """Called when the value of some entry widget has changed and the value
+        should be converted to uppercase."""
+        entry.set_text(entry.get_text().upper())
 
 #-----------------------------------------------------------------------------