Index: src/mlx/acft.py
===================================================================
--- src/mlx/acft.py	(revision 634)
+++ src/mlx/acft.py	(revision 635)
@@ -242,4 +242,11 @@
     def speedInKnots(self):
         """Indicate if the speed is in knots.
+
+        This default implementation returns True."""
+        return True
+
+    @property
+    def aglInFeet(self):
+        """Indicate if AGL altitudes are to be logged in feet.
 
         This default implementation returns True."""
@@ -990,4 +997,9 @@
         return False
 
+    @property
+    def aglInFeet(self):
+        """Indicate if AGL altituedes are in feet."""
+        return False
+
     def _appendLightsLoggers(self):
         """Append the loggers needed for the lights."""
@@ -1034,4 +1046,9 @@
 
     @property
+    def aglInFeet(self):
+        """Indicate if AGL altituedes are in feet."""
+        return False
+
+    @property
     def derateType(self):
         """Get the derate type for this type."""
@@ -1074,4 +1091,9 @@
     def speedInKnots(self):
         """Indicate if the speed is in knots."""
+        return False
+
+    @property
+    def aglInFeet(self):
+        """Indicate if AGL altituedes are in feet."""
         return False
 
Index: src/mlx/checks.py
===================================================================
--- src/mlx/checks.py	(revision 631)
+++ src/mlx/checks.py	(revision 635)
@@ -185,8 +185,9 @@
            flight.stage in [const.STAGE_TAKEOFF, const.STAGE_CLIMB]:
             logger.message(state.timestamp,
-                           "Initial climb speed: %.0f %s - %.0f ft AGL" % \
+                           "Initial climb speed: %.0f %s - %.0f %s AGL" % \
                            (flight.speedFromKnots(state.ias),
                             flight.getEnglishSpeedUnit(),
-                            state.radioAltitude))
+                            flight.aglFromFeet(state.radioAltitude),
+                            flight.getEnglishAGLUnit()))
             self._logged = True
 
@@ -697,7 +698,9 @@
         speed = logState.groundSpeed if logState.groundSpeed<80.0 \
                 else logState.ias
-        message = "Flaps %.0f - %.0f %s, %.0f ft AGL, %.0f ft AMSL" % \
+        message = "Flaps %.0f - %.0f %s, %.0f %s AGL, %.0f ft AMSL" % \
                (logState.flapsSet, flight.speedFromKnots(speed),
-                flight.getEnglishSpeedUnit(), logState.radioAltitude,
+                flight.getEnglishSpeedUnit(),
+                flight.aglFromFeet(logState.radioAltitude),
+                flight.getEnglishAGLUnit(),
                 logState.altitude)
 
@@ -715,9 +718,11 @@
     def _getMessage(self, flight, state, forced):
         """Get the message to log on a change."""
-        return "Gears SET to %s at %.0f %s, %.0f ft, %.0f ft AGL" % \
+        return "Gears SET to %s at %.0f %s, %.0f ft, %.0f %s AGL" % \
             ("DOWN" if state.gearControlDown else "UP",
              flight.speedFromKnots(state.ias),
              flight.getEnglishSpeedUnit(),
-             state.altitude, state.radioAltitude)
+             state.altitude,
+             flight.aglFromFeet(state.radioAltitude),
+             flight.getEnglishAGLUnit())
 
 #---------------------------------------------------------------------------------------
Index: src/mlx/flight.py
===================================================================
--- src/mlx/flight.py	(revision 609)
+++ src/mlx/flight.py	(revision 635)
@@ -321,4 +321,11 @@
         knots."""
         return self.aircraft.speedInKnots if self.aircraft is not None \
+               else True
+
+    @property
+    def aglInFeet(self):
+        """Determine if the AGL altutides for the flight are to be expressed in
+        feet."""
+        return self.aircraft.aglInFeet if self.aircraft is not None \
                else True
 
@@ -506,4 +513,9 @@
         return knots if self.speedInKnots else knots * const.KNOTSTOKMPH
 
+    def aglFromFeet(self, feet):
+        """Convert the given AGL altitude value expressed in feet into the
+        flight's AGL altitude unit."""
+        return feet if self.aglInFeet else feet * const.FEETTOMETRES
+
     def speedToKnots(self, speed):
         """Convert the given speed expressed in the flight's speed unit into
@@ -514,4 +526,8 @@
         """Get the English name of the speed unit used by the flight."""
         return "knots" if self.speedInKnots else "km/h"
+
+    def getEnglishAGLUnit(self):
+        """Get the English name of the AGL unit used by the flight."""
+        return "ft" if self.aglInFeet else "m"
 
     def getI18NSpeedUnit(self):