Index: doc/manual/en/index.html
===================================================================
--- doc/manual/en/index.html	(revision 493)
+++ doc/manual/en/index.html	(revision 725)
@@ -53,28 +53,30 @@
     or your ground speed becomes 5 knots or greater during the
     boarding stage, your flight enters this stage.</li>
-    <li><b>takeoff</b>: If you turn on the strobe lights
-    during taxi or after a rejected takeoff (RTO). If your plane's
-    strobe lights cannot be detected properly, switching the transponder
-    to mode C causes the program to enter into this stage. If your plane has
-    no strobe lights, the program will track your status after
-    exceeding 50 knots during the <i>taxi</i> stage, and if you lift
-    off within less than 40 seconds, it will be considered a takeoff.</li>
+    <li><b>takeoff</b>: If your ground speed exceeds 50 knots
+    during taxi or after a rejected takeoff (RTO), and then you lift-off in at
+    most 60 second, your flight enters the takeoff stage. The takeoff
+    configuration, however is saved at the time of exceeding 50 knots GS, but
+    will be checked and logged when leaving the ground. If you do not lift-off
+    within 60 seconds of exceeding 50 knots GS, a fault will be logged. If,
+    however, you check the <i>Rejected takeoff</i> checkbox on
+    the <a href="#takeOffPage"><i>Takeoff</i></a> page, the fault will
+    disappear and your flight will enter the <b>RTO</b> (rejected takeoff)
+    stage.</li>
     <li><b>climb</b>: When you retract the gears or you reach 3000
     feet altitude AGL with a positive climb rate after takeoff.</li>
-    <li><b>RTO</b>: If you switch off both the landing and the
-    strobe lights, and your speed is reduced below 50 knots while on
-    the ground during takeoff.</li>
     <li><b>cruise</b>: When the aircraft's altitude is within 2000
-    feet of the cruise altitude and you are climbing.</li>
+    feet of the cruise altitude and you are climbing either after takeoff or an
+    aborted approach or landing.</li>
     <li><b>descent</b>: If the altitude decreases to more than 2000
     feet below the cruise altitude during cruise.</li>
     <li><b>landing</b>: If the gears are lowered and the altitude is
-    less than 2000 feet AGL during descent or go-around.</li>
+    less than 2000 feet AGL during descent or go-around. Also when you start
+    to descend during a climb and the previous conditions also hold.</li>
     <li><b>go-around</b>: If you retract the gears during landing.</li>
     <li><b>taxi after landing</b>: When the aircraft is in the
-    ground and its ground speed is below 50 knots after landing.</li>
+    ground and its ground speed is below 25 knots after landing.</li>
     <li><b>end</b>: If the N<sub>1</sub> of the turbines becomes
     less than 0.5, or the RPM of the piston engines becomes 0 during
-    parking. This is the final stage.</li>
+    the parking brakes are set. This is the final stage.</li>
   </ol>
 
@@ -235,5 +237,6 @@
   notify the author if this happens. In this case, try to copy and
   save the <a href="#debugLog">debug log</a> and send it with your bug
-  report.
+  report. You can use the <a href="#bugReportWindow">bug
+  reporting</a> facility as well for this purpose.
   </p>
 
Index: doc/manual/hu/index.html
===================================================================
--- doc/manual/hu/index.html	(revision 493)
+++ doc/manual/hu/index.html	(revision 725)
@@ -53,26 +53,29 @@
     5 csomót, a program ebbe a fázisba lép.</li>
     <li><b>felszállás</b>: Ha kigurulás közben vagy megszakított
-    felszállás után felkapcsoljuk a villogót. Ha a repülőgép
-    villogójának állapota nem érzékelhető, a transzponder C módba
-    állítására is ebbe a fázisba kerül a program. Ha a repülőgép
-    egyáltalán nem rendelkezik villogóval, a program 50 csomós
-    sebesség túllépésekor elkezd figyelni, és ha 40 másodpercen belül
-    elemelkedünk, azt is felszállásnak veszi.</li>
+    felszállás után túllépjük az 50 csomós földhöz viszonyítot sebességet,
+    majd 60 másodpercen belül elemelkedünk, az elemelkedést követően lép a
+    program felszállási fázisba. A felszálló konfigurációt azonban az
+    50 csomó túllépésének időszakában menti el, majd a fázisba való
+    belépés pillanatában ellenőrzi, illetve írja a naplóba. Ha az 50 csomó
+    túllépését követően 60 másodpercen belül nem emelkedünk el, a program
+    hibát naplóz. Ha azonban ezután a
+    <a href="#takeOffPage"><i>Felszállás</i></a> oldalon bejelöljük a
+    <i>Megszakított felszállás</i> jelölőnégyzetet, a hiba eltűnik és
+    <b>megszakított felszállás</b> fázisba lép a program.</li>
     <li><b>emelkedés</b>: Ha felszállás közben behúzzuk a futóműveket
     vagy elérjük a reptérhez viszonyított 3000 láb magasságot.</li>
-    <li><b>megszakított felszállás</b>: Ha felszállás közben még a
-    földön vagyunk, és kikapcsoljuk mind a leszálló fényeket, mind a
-    villogót, vagy a sebesség 50 csomó alá csökken.</li>
-    <li><b>utazó</b>: Ha emelkedés közben az utazómagasságot 2000
-    lábnyira megközelítjük.</li>
+    <li><b>utazó</b>: Ha felszállás utáni, vagy megszakított megözelítés vagy
+    leszállást követő emelkedés közben az utazómagasságot 2000 lábnyira
+    megközelítjük.</li>
     <li><b>süllyedés</b>: Ha az utazó fázis közben a repülési magasság
     több mint 2000 lábbal az utazó magasság alá csökken.</li>
     <li><b>leszállás</b>: Ha süllyedés vagy átstartolás közben a
     futóműveket kiengedjük és a reptérhez viszonyítva 2000 láb alá
-    csökken a magasság.</li>
+    csökken a magasság. Valamit akkor is, ha emelkedés közben süllyedni
+    kezdünk és az előbbi feltételek is fennálnak.</li>
     <li><b>átstartolás</b>: Ha leszállás közben visszahúzzuk a futóműveket.</li>
     <li><b>begurulás</b>: Ha leszállás után a repülőgép a földön gurul
-    és a sebessége 50 csomó alá csökken.</li>
-    <li><b>vége</b>: Ha parkolás közben a gázturbinák N<sub>1</sub>
+    és a földhöz viszonyított sebessége 25 csomó alá csökken.</li>
+    <li><b>vége</b>: Ha a parkolófékeket behúzzük és a gázturbinák N<sub>1</sub>
     paramétere 0,5 alá, vagy a dugattyús motorok fordulatszáma
     0-ra csökken. Ez a járat teljesítésének utolsó fázisa.</li>
@@ -232,5 +235,6 @@
   járat újrakezdése. Ebben az esetben feltétlenül értesítsük a
   szerzőt, és az értesítésbe másoljuk be a <a href="#debugLog">debug
-  napló</a> tartalmát.
+  napló</a> tartalmát. Erre használhatjuk
+  a <a href="#bugReportWindow"><i>Hibajelentés</i></a> funkciót is.
   </p>
 