Index: MLXMANIFEST
===================================================================
--- MLXMANIFEST	(revision 884)
+++ MLXMANIFEST	(revision 890)
@@ -4,9 +4,9 @@
 library/fnmatch.pyc	3414	4d50000f78e903598af06ef1c5cfb3ef
 library/multiprocessing/managers.pyc	36290	ca35d24d87467303c5e94a0de51e9593
-library/gtk/_gtk.pyc	549	5774db369f84d6d9a75a5d0976e8bb54
+library/gtk/_gtk.pyc	549	fe4816d7315373754a9c2a78c1cb910d
 library/encodings/cp858.pyc	7591	02054a0b8e91b9758826eb70cddf096f
 library/encodings/cp1254.pyc	2678	17ff2ac86f90886d5c73ed789f0499f3
 library/encodings/unicode_internal.pyc	2022	1e902113491e0c334b44deb0c8940e01
-library/lxml/etree.pyc	555	fda033a44653f65ac922d14451df4e72
+library/lxml/etree.pyc	555	4cedd864ad5b158d44762634ecc002c9
 library/encodings/gbk.pyc	1622	71c1e7fe25116114241829a60e57c5f4
 sounds/speed.mp3	26331	3d64da0eea9f48fa73be82d385354bf6
@@ -100,5 +100,5 @@
 library/encodings/koi8_r.pyc	2700	fff1b35002b9e938b7ea6fd0fbe824ae
 sounds/737taxi.mp3	157362	846c403e5cb660be53c8b6da16b68234
-library/mlx/const.pyc	7504	373fc70af7d96a5475ea23665e047eb7
+library/mlx/const.pyc	7504	d661c08870a0056cb2b4bab198de8c34
 python27.dll	2206720	f8f39495ed4a813e8f3049a4b9f5cff4
 locales/th.pak	13637	7262d0f5e1877212a45a1ef1ccc4c777
@@ -118,5 +118,5 @@
 library/email/header.pyc	13339	f741f4c3543a278fec30f4d9bdd0f859
 library/share/locale/hu/LC_MESSAGES/atk10.mo	8465	e3f3466da367215aad971d7b0394229d
-library/select.pyc	543	ba179c7bddf9828eb4ea8063b2f880d7
+library/select.pyc	543	64632c3b8962883ab952e483a722d0f9
 library/encodings/uu_codec.pyc	4646	5282a5fcb676851224d2924aa3e48a9e
 library/ConfigParser.pyc	23857	1d17020dd0000ce0f73de812effa152f
@@ -158,10 +158,10 @@
 doc/manual/hu/flightSelection.png	32828	68562091faef606b1247e5d3a40c488e
 library/win32pipe.pyd	24064	de374eded459293b2a7eb8ed8fb38eaa
-library/win32pipe.pyc	552	cc9e885be592b152d2f79283e87aafd8
+library/win32pipe.pyc	552	481d263642893856d1c992f484f380aa
 doc/manual/hu/cruise.png	27925	f7045d9150a756f487e3ae3d08b4c1a5
 library/encodings/iso2022_jp_2004.pyc	1723	66376e788f3819e781897268c1100986
 library/cefpython3.cefpython_py27.pyd	968192	58161b73feae974f560d2c9f416adf3b
 library/encodings/cp866.pyc	8103	f36418dcf93b17b3ced63bd544f44159
-library/gio/_gio.pyc	549	bada60674cc3669872766e42a0a37383
+library/gio/_gio.pyc	549	ce68d42eef1532c1ec170b997a7fdebd
 library/encodings/cp437.pyc	7874	63f1278c0a66129c6fb4f504d6b61b66
 doc/manual/hu/prefsSounds.png	22667	452c396c2bda9684bf052c98fd7870d1
@@ -175,8 +175,8 @@
 doc/manual/hu/acarsTab.png	305091	489953210460410f2ec9d281b7ad6868
 library/encodings/utf_32_be.pyc	1747	3e8c9ef8145de502320202b1688fd2ee
-library/cefpython3/cefpython_py27.pyc	600	d967b26ad49dda402d6848721b99269f
+library/cefpython3/cefpython_py27.pyc	600	22895e1b76e628cfe1126552651999d4
 library/encodings/mac_romanian.pyc	2756	a3b2a0892236bc80c8efe8940e33339e
 library/multiprocessing/connection.pyc	13385	c86567e4a002e8beca2301d1110b887c
-library/_ctypes.pyc	546	3379e8f8225825b23075a2fd2a176660
+library/_ctypes.pyc	546	ea964009a19c93c9b7e6d5a0952d740b
 Microsoft.VC90.CRT/Microsoft.VC90.CRT.manifest	1856	a1328f4f5ae0580ce72b0717893c9072
 library/encodings/iso8859_2.pyc	2678	da65f42e1be5bec97161e8c1cc4f0fb7
@@ -197,5 +197,5 @@
 library/unittest/case.pyc	37758	1d2235e74c246b562c5c00ddf73c621a
 library/subprocess.pyc	38648	c9f749db06dfc9fb32079de51d6efd01
-library/mlx/acft.pyc	42418	c7999feebb5011a550cea4ed5757f517
+library/mlx/acft.pyc	42418	ab4080e74ed57c8608a662d38dd9f5c2
 library/gobject._gobject.pyd	113152	3d05dd191361f83aa247b62c700fa04e
 doc/manual/hu/checklistEditor.png	27863	8c750892a52dc10ca654a9d0b2765358
@@ -206,5 +206,5 @@
 library/encodings/cp864.pyc	7999	ca90afae086cb6b8f69b8419cc3cd1cb
 library/pyexpat.pyd	152576	5a82e9ec95005aca6130751e5b961cc3
-library/pyexpat.pyc	546	b32b38ba89625019c7d7b4d6d4520863
+library/pyexpat.pyc	546	c0175ad3bb5cd86249bf1cef3e3a560f
 library/unittest/loader.pyc	10884	591a785be23fba35582ce33bdd3d7acd
 library/ftplib.pyc	32043	5a1925388a0874e459aed6891f4cf0c1
@@ -257,5 +257,5 @@
 library/encodings/iso8859_10.pyc	2693	5e6cc8f721486ddbc1c99da285e13191
 library/mlx/config.pyc	33266	a7d9c1089d89b2eae06344b4eb62b515
-library/atk.pyc	534	6af9c4ad47c4193f16bf48a9077053dc
+library/atk.pyc	534	696d668cfdc42d4ddb0973dec25e43af
 library/gio._gio.pyd	263168	acb8c95fdc391079bebdf7d8685b0dbc
 library/encodings/cp861.pyc	7868	c97a8970ce4d9f40cbafbea6576fbdca
@@ -293,5 +293,5 @@
 locales/sr.pak	10790	fd63b700458a187aca8dde86c160a059
 doc/manual/hu/registration.png	31260	877f209cc012ce6b3335368276babcc6
-library/gobject/_gobject.pyc	573	d0d92ee2892896664dcbb5a67efc3784
+library/gobject/_gobject.pyc	573	9c208b5682178410d144235e4e0dc566
 libcef.dll	38585344	4dfb8a77f35c41bdbe8469877d4af853
 library/encodings/utf_7.pyc	1747	2beeb059236527197d6c640396476ce8
@@ -306,5 +306,5 @@
 doc/manual/hu/monitorWindow.png	21499	c8296e51e14588ac5b037b4832161dfc
 library/pangocairo.pyd	17920	5fc69a7d29a6d3127710c64de440daa4
-library/pangocairo.pyc	555	7c73051324cf55d9c0fa17a8926f8eb3
+library/pangocairo.pyc	555	28af83fc19cded4fc98ec58484387a76
 library/zipfile.pyc	37345	568c6ee7e0404625f47248340afb4524
 locales/it.pak	7188	10ae10d8bfcffbfa1160574134e14edb
@@ -328,5 +328,5 @@
 locales/fi.pak	7098	70c7e2fb26c7abf09cb0f9972fb6c93a
 doc/manual/en/monitorWindow.png	20886	42e08d10c758e21209c4c021f391dee7
-library/_hashlib.pyc	549	6d09558c5e695579aad0eb01083d6a8d
+library/_hashlib.pyc	549	1165d901defce2ba71812217e87d6f91
 library/copy.pyc	11674	30d1745c5e38ab170f8a0486fbebf305
 locales/et.pak	6856	18a0a857e46c28b7f1cd8ff639a24aec
@@ -349,5 +349,5 @@
 sounds/taps.mp3	16614	d4a019c7e9342ae329aee6932d6a43c3
 library/markupbase.pyc	9010	b33ff430e9b1adba3d540b5394ff289a
-library/cairo/_cairo.pyc	561	af24913a5832c127da2872bfee31b72f
+library/cairo/_cairo.pyc	561	5f0ebf0e8ff791c32ffb875ada20d672
 locales/te.pak	16110	c3af85e60b78273a93970cf8805ded04
 library/lxml/cssselect.pyc	3861	2e693f0c25ab04b1d130646cddd4e081
@@ -379,10 +379,10 @@
 library/encodings/iso8859_16.pyc	2695	85e819a29dec2b601ce978dcd5a040fc
 sounds/cpt_takeoff.mp3	8255	254edcf79b8b3752d1a7c191c57f615a
-library/bz2.pyc	534	ec7ac31c92f6d7a57c130599e146432b
+library/bz2.pyc	534	7b01882aa537ced5392bfd6a05c92bee
 library/email/utils.pyc	8840	a7be428df6fddee6121cfce55382d1f8
 doc/manual/en/prefsGeneral.png	25633	a5ef76b874f4ad5384b519a11bdf9c47
 library/encodings/iso2022_jp_2.pyc	1699	4b917caa926e5779176612409c66be39
 library/_ssl.pyd	720896	90826a140137efd0d806038828e16f8e
-library/pango.pyc	540	375fd6395ae1c28e3ab95963a17ad7ac
+library/pango.pyc	540	1c0e90e57415e1e74c0b496cce34a7f5
 doc/manual/en/flightBooking.png	37170	266bd9c93de3a1449b51854a05b98366
 library/glib/__init__.pyc	187	d44c8c2772b263a36726ac0dcfc04b42
@@ -390,5 +390,5 @@
 library/libgobject-2.0-0.dll	341594	356d697647a480562c4e2e921b13f8ed
 doc/manual/hu/acceptedFlights.png	43527	6c52b86433a227efed500f27769aef97
-mlxupdate.exe	19456	035facbe3db9536292d4b90999cf0ff3
+mlxupdate.exe	19456	9b19d587509c61dcc52b91a871d0f675
 library/email/errors.pyc	3229	cdb78ab237e195ad69f059128bc03b1d
 library/linecache.pyc	3091	666e6f81b0ea9a7637f8068493f738d5
@@ -401,5 +401,5 @@
 library/getopt.pyc	6454	8f8cd6763f5339988d157d153c910bf5
 library/encodings/cp857.pyc	7611	1b46c8959ac097b73e1c680d464cdc32
-library/_ssl.pyc	537	b144982972ab01929abbb5795b57398d
+library/_ssl.pyc	537	244c691a5e5f65839b6a8dcba79e2e88
 library/os2emxpath.pyc	4312	0c35794eeb4739ebb4eb28b9a1daf0ca
 library/pprint.pyc	9852	6b4724e14285c257116655b1d4ba6db1
@@ -415,5 +415,5 @@
 library/encodings/cp1252.pyc	2676	b4c43cc72650c911cf3654dbaf565df9
 library/unicodedata.pyd	688128	c856c31a03dc892e4f2aee93d0bfee44
-library/unicodedata.pyc	558	274b91e945c75eece0ce2aa674b85162
+library/unicodedata.pyc	558	1d02ca413783825aeb8e6b3976f0add4
 library/multiprocessing/sharedctypes.pyc	8069	0b5a57d8a8a1562a9d562edabd5065c1
 library/encodings/cp1256.pyc	2675	c1bf26ed9c9b5ee0eec495138993cffb
@@ -465,8 +465,8 @@
 library/multiprocessing/heap.pyc	6104	71b50576901ea09d8e4666a9a80724d3
 library/encodings/unicode_escape.pyc	1996	32990583f1caf874e556087da7b92971
-library/_multiprocessing.pyc	573	bb71788f233de911abd40db53301e97c
+library/_multiprocessing.pyc	573	75d775fe0fe2d2285eb0f31de28bacc4
 doc/manual/hu/logTab.png	28908	25b9aceb760189c177a5562c0cfa2a04
-library/win32event.pyc	555	5310e3b06656458a171072063088afb2
-library/win32file.pyc	552	20fcdee2765f2f43d41597418b55ed12
+library/win32event.pyc	555	d92a7808ed1848a5f745893510cb9249
+library/win32file.pyc	552	3b5fe9c088871cf707f54153c8680507
 library/_multiprocessing.pyd	28672	edd174951a2233941c8d2064c0f69a68
 library/encodings/shift_jis_2004.pyc	1710	f8bb22a8b02dba2b66b7f77122c98fd6
@@ -515,5 +515,5 @@
 doc/manual/hu/gateSelection.png	31891	937dc56457188df05056c0f9f3a53975
 library/cmd.pyc	13512	808f813d5e354b7073a1356e44c7b554
-library/mlx/rpc.pyc	23499	1996eff086d7cfe2c20b18c69a5f5f54
+library/mlx/rpc.pyc	24596	1c6827ff7711034037cc8755f8dca8af
 locales/ko.pak	7278	41ecc83d5eef5887c7c288b3b570c7b4
 library/jsonrpclib/history.pyc	1662	2e0e6d5c26e2794085d62feb524e4542
@@ -536,9 +536,9 @@
 library/_socket.pyd	38400	5d273be76603399e88cf57f2605004bf
 library/plistlib.pyc	18067	d8d36573e80bfdde7c73e47828f6e710
-library/_socket.pyc	546	76ac8cac2779851fb8c9d332ee9e3851
+library/_socket.pyc	546	e20437226441ba8d2569ed7e3a281b50
 library/encodings/hex_codec.pyc	3520	a8b8d5b7c8810379c7007bcbc253951c
 library/mlx/sound.pyc	12511	1cb833d4bb47c63572bef0fc1e0a675d
-library/glib/_glib.pyc	555	549947841acb8f4212457fda2e238104
-library/win32api.pyc	549	928afba3405f673c781f7272808c0b5d
+library/glib/_glib.pyc	555	964f3f75bc28dfdca564030e97b8ea1a
+library/win32api.pyc	549	7feab59155c5af902ecbe162cdd768b5
 library/encodings/iso8859_13.pyc	2696	f901ae0bbcfbb78f0c1783e89b2e2dc5
 doc/manual/en/index.html	59898	7a24695cf320678b5995a390ad369d4c
@@ -575,5 +575,5 @@
 locales/sk.pak	7622	dfdff6206e5a79aef8b46d0d9c2a8367
 library/select.pyd	11776	d90bf525f9f6c9c3aa6532fa6e569b4f
-library/pyuipc.pyc	543	49a1c4ea50bf97349cb26cfd745baa00
+library/pyuipc.pyc	543	9cfd3ec36a463e39df7baa62f6b971e8
 library/locale.pyc	48754	a51d20267132acc6bc66ac6252cf870f
 doc/manual/en/logTab.png	28120	b92cf63420e59e0c48da4f0b3baae040
@@ -585,5 +585,5 @@
 library/distutils/errors.pyc	5885	fbeaddf5d59ea781ec63197dd950aa89
 library/logging/__init__.pyc	54813	7bcdf2e8da474f5e94d8e499f6fc3ed4
-runmlx.exe	64000	c254f809cf8f0d5a592e2ac0ab5e654b
+runmlx.exe	64000	010b7fa1b6da6f77072342815123917e
 locales/zh-CN.pak	6386	36e1df83611aef6fbfeeafd067dd4241
 locales/hi.pak	13321	4b6b27ab4421c94685fc09051a2339f8